#include "createRDS.hh"
#include "Frame.hh"
#include "rdsframe.hh"
#include "rdsreduce.hh"
#include "rdsresample.hh"
#include "RDSStreamMemory.hh"

namespace FrameAPI
{
  Frame
  createRDS( frame_file_container_type FrameFiles,
	     start_type Start,
	     end_type End,
	     channel_container_type Channels )
  {
    RDSFrame::Options	opts( Start,		// Start Time
			      End,		// End Time
			      "__none__",	// Output Type
			      "",		// Compression - raw
			      0,		// Compression - level
			      false,		// Verify Checksum
			      false,		// Verify Frame Checksum
			      false,		// Verify Time Range
			      false,		// Verify Data Valid
			      1,		// FramesPerFile
			      End - Start,	// SecondsPerFrame
			      true,		// AllowShortFrames
			      false,		// GenerateFrameChecksum
			      true,		// FillMissingDataValidArray
			      false );		// VerifyFilenameMetadata
    RDSStreamMemory*
      stream( new RDSStreamMemory( ) );

    RDSFrame::stream_type	output;
    Frame			retval;

    output.reset( stream );
    ReduceRawFrame
      request( FrameFiles,	// Filename list
	       Channels,	// Channel list
	       opts );
    request.ProcessRequest( output );
    if ( output )
    {
      retval = stream->Results( )[ 0 ];
    }

    return retval;
  }
}
